/* cmd_neonfun_unoplay.c - NeonServ v5.6
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_neonfun.h"
#include "game_uno.h"

CMD_BIND(neonfun_cmd_unoplay) {
    struct ChanUser *chanuser = getChanUser(user, chan);
    if(!chanuser) return;
    struct uno_game *game;
    for(game = uno_active_games; game; game = game->next) {
        if(chan == game->channel) {
            if(game->state == UNO_STATE_WAITING)
                return;
            else 
                break;
        }
    }
    if(game) {
        //check if it's the player's turn
        if(game->active_player->chanuser != chanuser) {
            reply(textclient, user, "NF_UNO_NOT_YOUR_TURN");
            return;
        }
        game->active_player->timeout = 0;
        struct uno_card *card = uno_parse_card(game, game->active_player, argv[0]);
        if(!card) return;
        unsigned char new_color = card->color;
        if(card->card == UNO_CARD_ADD_4 || card->card == UNO_CARD_COLOR) {
            if(argc < 2) {
                reply(game->textbot, user, "NF_UNO_DEFINE_COLOR");
                return;
            }
            if(!stricmp(argv[1], "RED") || !stricmp(argv[1], "R") || !stricmp(argv[1], get_language_string(user, "NF_UNO_CARD_RED"))) {
                new_color = UNO_COLOR_RED;
            } else if(!stricmp(argv[1], "BLUE") || !stricmp(argv[1], "B") || !stricmp(argv[1], get_language_string(user, "NF_UNO_CARD_BLUE"))) {
                new_color = UNO_COLOR_BLUE;
            } else if(!stricmp(argv[1], "GREEN") || !stricmp(argv[1], "G") || !stricmp(argv[1], get_language_string(user, "NF_UNO_CARD_GREEN"))) {
                new_color = UNO_COLOR_GREEN;
            } else if(!stricmp(argv[1], "YELLOW") || !stricmp(argv[1], "Y") || !stricmp(argv[1], get_language_string(user, "NF_UNO_CARD_YELLOW"))) {
                new_color = UNO_COLOR_YELLOW;
            } else {
                reply(game->textbot, user, "NF_UNO_DEFINE_COLOR");
                return;
            }
        }
        if(uno_check_card_valid(game, card)) {
            reply(game->textbot, user, "NF_UNO_CARD_NOT_POSSIBLE");
            return;
        }
        card->color = new_color;
        uno_play_card(game, game->active_player, card);
    }
}
