/* cmd_neonserv_info.c - NeonServ v5.6
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_neonserv.h"

/*
* no parameters
*/

CMD_BIND(neonserv_cmd_info) {
    MYSQL_RES *res;
    MYSQL_ROW row, row2;
    struct Table *table;
    printf_mysql_query("SELECT `channel_defaulttopic`, `channel_modes`, `channel_maxusers`, `channel_lastvisit`, `channel_registered`, `user_user` FROM `channels` LEFT JOIN `users` ON `channel_registrator` = `user_id` WHERE `channel_id` = '%d'", chan->channel_id);
    res = mysql_use();
    row = mysql_fetch_row(res);
    table = table_init(2, 9, 0);
    table_set_bold(table, 0, 1);
    char *content[2];
    reply(textclient, user, "NS_INFO_HEADER", chan->name);
    content[0] = get_language_string(user, "NS_INFO_DEFAULTTOPIC");
    content[1] = row[0];
    table_add(table, content);
    content[0] = get_language_string(user, "NS_INFO_MODELOCK");
    content[1] = row[1];
    table_add(table, content);
    content[0] = get_language_string(user, "NS_INFO_RECORD");
    content[1] = row[2];
    table_add(table, content);
    printf_mysql_query("SELECT `user_user`, `chanuser_access` FROM `chanusers` LEFT JOIN `users` ON `user_id` = `chanuser_uid` WHERE `chanuser_cid` = '%d'", chan->channel_id);
    res = mysql_use();
    char ownerstr[MAXLEN];
    int ownerpos = 0, usercount = 0;
    int userisowner = 0;
    while((row2 = mysql_fetch_row(res))) {
        if(!strcmp(row2[1], "500")) {
            ownerpos += sprintf(ownerstr + ownerpos, (ownerpos ? ", %s" : "%s"), row2[0]);
            if((user->flags & USERFLAG_ISAUTHED) && !stricmp(row2[0], user->auth))
                userisowner = 1;
        }
        usercount++;
    }
    content[0] = get_language_string(user, "NS_INFO_OWNER");
    content[1] = ownerstr;
    table_add(table, content);
    sprintf(ownerstr, "%d", usercount);
    content[0] = get_language_string(user, "NS_INFO_USERS");
    content[1] = ownerstr;
    table_add(table, content);
    printf_mysql_query("SELECT COUNT(*) FROM `bans` WHERE `ban_channel` = '%d'", chan->channel_id);
    res = mysql_use();
    row2 = mysql_fetch_row(res);
    content[0] = get_language_string(user, "NS_INFO_BANS");
    content[1] = row2[0];
    table_add(table, content);
    content[0] = get_language_string(user, "NS_INFO_VISITED");
    content[1] = timeToStr(user, time(0) - atoi(row[3]), 2, ownerstr);
    table_add(table, content);
    if(strcmp(row[4], "0")) {
        content[0] = get_language_string(user, "NS_INFO_REGISTERED");
        content[1] = timeToStr(user, time(0) - atoi(row[4]), 2, ownerstr);
        table_add(table, content);
    }
    if(row[5] && isGodMode(user)) {
        content[0] = get_language_string(user, "NS_INFO_REGISTRAR");
        content[1] = row[5];
        table_add(table, content);
    }
    char **table_lines = table_end(table);
    int i;
    for(i = 0; i < table->entrys; i++) {
        reply(textclient, user, table_lines[i]);
    }
    table_free(table);
    if(userisowner || isGodMode(user)) {
        printf_mysql_query("SELECT `owner_history_time`, a.`user_user`, b.`user_user` FROM `owner_history` LEFT JOIN `users` a ON `owner_history_from_uid` = a.`user_id` LEFT JOIN `users` b ON `owner_history_to_uid` = b.`user_id` WHERE `owner_history_cid` = '%d'", chan->channel_id);
        res = mysql_use();
        if(mysql_num_rows(res)) {
            reply(textclient, user, "NS_INFO_OWNERLOG", chan->name);
            time_t rawtime;
            struct tm *timeinfo;
            char timeBuf[80];
            while((row = mysql_fetch_row(res))) {
                rawtime = (time_t) atol(row[0]);
                timeinfo = localtime(&rawtime);
                strftime(timeBuf, 80, "%c", timeinfo);
                reply(textclient, user, "NS_INFO_OWNERCHANGE", row[1], row[2], timeBuf);
            }
        }
    }
}
